# Download and Install SkyHanni

SkyHanni is a Forge mod for **Minecraft 1.8.9 only**.
Trying to run this on Badlion, Lunar, Feather, or newer versions of Minecraft is **not supported**.

Follow this guide to install SkyHanni in regular Minecraft Forge.
If you already have Forge mods, you can skip to step 4. Otherwise, start from step 1.
If you already have the latest alpha version from NEU, you can skip to step 5.

<details>
<summary>1. Run vanilla 1.8.9</summary>

Run Minecraft 1.8.9, unmodded, for 10 seconds, then close it.

</details>


<details>
<summary>2. Install Java</summary>

To play with mods, you need Java.
Install [Java 8](https://www.java.com/download/ie_manual.jsp).
Double-click the file to install it.

</details>


<details>
<summary>3. Install Forge</summary>

Forge is the system that loads your mods into the game.
You need Java to run Forge.
Download [Forge for 1.8.9](https://files.minecraftforge.net/net/minecraftforge/forge/index_1.8.9.html).
Click installer, when you double-click the file, install as client.
If Forge does not open with Java, download [Jarfix](https://johann.loefflmann.net/en/software/jarfix/index.html),
double click it, then try running Forge again.

</details>


<details>
<summary>4. Download NEU</summary>

Neu is NotEnoughUpdates, another Forge mod that contains files that SkyHanni depends on to function.
You can install it from [Moulberry's Bush Discord Server](https://discord.gg/moulberry) in the
channel [#🧪neu-alphas](https://discord.com/channels/516977525906341928/1028896920346841118) or
from [SkyHanni Discord](https://discord.com/invite/skyhanni-997079228510117908) in the
channel [#neu-updates](https://discord.com/channels/997079228510117908/1123201092193366027)

</details>


<details>
<summary>5. Download SkyHanni</summary>

SkyHanni has two different update circles: [Full Release](https://github.com/hannibal002/SkyHanni/releases/latest)
and [Beta](https://github.com/hannibal002/SkyHanni/releases).

In general, it is recommended to use the **Full Release**.
It updates every 3–4 weeks and should run very stable.
If you find bugs or miss features in the full version, they might be fixed/implemented already in a beta version.

The **Beta Version**, on the other hand, gets updated multiple times a week,
has new features earlier, but also may contain more bugs.

</details>


<details>
<summary>6. Find .minecraft</summary>

Once you have downloaded both NEU and SkyHanni, you need to navigate to your `.minecraft` folder.
On Windows, open file explorer, in the file location bar at the top type in `%appdata%` and open `.minecraft`.
On Mac, go to `~/Library/Application Support/minecraft`.

</details>


<details>

<summary>7. Move mods into mods folder</summary>

If there is a "mods" folder, great! Open it.
Otherwise, create one and name it exactly "mods".

Move both your downloaded NEU file and SkyHanni file into the folder.
(If you have already an older version of NEU or SkyHanni in that folder, delete it.)

*Note: if you have a problem, people may ask to see your mod folder - that is this folder.*

</details>


<details>
<summary>8. Setup RAM</summary>

If you're running mods, you also need to set up your allocated ram.
If you don't know how much ram your computer has,
follow [this guide](https://www.howtogeek.com/435644/how-to-see-how-much-ram-is-in-your-pc-and-its-speed/).
To allocate ram, go to installation, press the 3 dots next to the installation you are using,
click edit, press more options.
In JVM arguments, look for something that says -Xmx2G or some other number followed by G.
That number is the amount you have allocated for Minecraft to use.
If you have 2G of ram on your computer, you might struggle to play Minecraft.
Try to allocate 1G. If you have 4G, allocate 2G. If you
have 8 or more G, allocate 4G.
You should never need more than 4G, unless you have more mods, than you know what to do.

</details>


<details>
<summary>9. Launch the Forge profile in the launcher</summary>

Installing Minecraft Forge should have set the profile for you, but if it didn't, go to installations,
select new installation, under version you need to find Forge for 1.8.9 (most likely at the top or bottom)

</details>


<details>
<summary>10. Recommended additional mods (optional)</summary>

[OptiFine](https://optifine.net/adloadx?f=preview_OptiFine_1.8.9_HD_U_M6_pre2.jar)
and either [Sk1erLLC's Patcher](https://sk1er.club/mods/patcher) or [Polyfrost's PolyPatcher](<https://modrinth.com/mod/patcher>) (a fork of Patcher with OneConfig, slightly different features, and bug fixes, including fixed cactus hitboxes)

Those two mods help you get more FPS in game and let you change many more performance
settings.

*Ask on discord if you need help with those.*

</details>

<h2>And finally, don't forget to <i><b>never run a file that is sent to you in dms</b></i></h2>
